# std::basic_ifstream<CharT,Traits>::open

From cppreference.com
< cpp‎ | io‎ | basic ifstream

void open( const char *filename, ios_base::openmode mode = ios_base::in ); | (1) |
void open( const std::filesystem::path::value_type *filename, ios_base::openmode mode = ios_base::in ); | (2) | (since C++17)
void open( const std::string &filename, ios_base::openmode mode = ios_base::in ); | (3) | (since C++11)
void open( const std::filesystem::path &filename, ios_base::openmode mode = ios_base::in ); | (4) | (since C++17)

Opens and associates the file with name `filename` with the file stream.

Calls setstate(failbit) on failure.

Calls clear() on success. | (since C++11)

1-2) Effectively calls rdbuf()->open(filename, mode | ios_base::in). (see std::basic_filebuf::open for the details on the effects of that call). Overload (2) is only provided if std::filesystem::path::value_type is not char. (since C++17)
3-4) Effectively calls (1-2) as if by open(filename.c_str(), mode).

### Parameters

filename | - | the name of the file to be opened

mode

-

specifies stream open mode. It is bitmask type, the following constants are defined:

Constant | Explanation
`app` | seek to the end of stream before each write
`binary` | open in binary mode
`in` | open for reading
`out` | open for writing
`trunc` | discard the contents of the stream when opening
`ate` | seek to the end of stream immediately after open

### Return value

(none)

### Example

| This section is incomplete Reason: no example

### See also

is_open | checks if the stream has an associated file (public member function)
close | closes the associated file (public member function)
open | opens a file and configures it as the associated character sequence (public member function of `std::basic_filebuf<CharT,Traits>`)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/io/basic_ifstream/open&oldid=50840"